import {
  scaleLinear,  
  scaleBand,
  axisLeft,
  axisBottom,
  max
} from 'd3';

  const width = 350
  const height = 400
  const length =1
  const xValue = d => d[1]
  const yValue = d => d[0]
  
  const margin = { 
    top:130, 
    right:0, 
    bottom:50, 
    left: 20};

  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  const colorScale = {
  	"McDonald's":'#fffa05', 
    "Burger King":'#b21dc3', 
    "Taco Bell":'#2494fd',
    "Wendy's":'#fe2323', 
    "Arby's":'#fcc725',
    "KFC":'#fb7217',
    "Subway":'#7bfd24',
    "other": '#545454'
  }      
        
  const colorFont = {
    "McDonald's":'#000000', 
    "Burger King":'#ffffff', 
    "Taco Bell":'#ffffff',
    "Wendy's":'#ffffff', 
    "Arby's":'#000000',
    "KFC":'#ffffff',
    "Subway":'#000000',
    "other": '#ffffff'
    }

export const chart = (data, props) => {
  const {
     selection,
     selection2,
     selection3,
     target,
     off_chart,
   } = props;
      
 console.log(+(off_chart==1))
  
 const xScale = scaleLinear()
    .domain([0, max(data, xValue)])
    .range([0, innerWidth]);
  
  const yScale = scaleBand()
    .domain(data.map(d => d[0]))
    .range([0, innerHeight])
    .padding(0.1);

  const groups = selection.selectAll('g').data(data)
  const groupsEnter = groups.enter().append('g')
  groupsEnter 
   .attr('transform', `translate(${margin.left},${margin.top})`)
  .merge(groups) 
   .attr('opacity',(+(off_chart==1))?0:1);

  
  const ylab = selection2.selectAll('text').data(data)
  const ylabEnter = ylab.enter().append('text')
  ylabEnter 
   .attr('transform', `translate(${margin.left},${margin.top})`)
  .merge(ylab) 
   .attr('opacity',(+(off_chart==1))?0:1);

  
  
  const title = selection3.selectAll('text').data([null])
  const titleEnter = title.enter().append('text')
  titleEnter 
   .attr('transform', `translate(${margin.left},${margin.top})`)
  .merge(title) 
   .attr('opacity',(+(off_chart==1))?0:1);
   
  
groupsEnter.append('rect')
  .merge(groups.select('rect'))
    .transition()
      .duration(750)
      .attr('rx',10) 
      .attr('y', d => yScale(yValue(d)))
      .attr('fill', d => 
    (+(colorScale.hasOwnProperty(d[0]))) ? colorScale[d[0]] : colorScale["other"])
     
      .attr('width', d => xScale(xValue(d)))
      .attr('height', yScale.bandwidth());
      


groupsEnter.append('text')
  .merge(groups.select('text'))
    .transition()
     .duration(250)
     .text(d => d[1])
     .attr('fill','white')
     .attr('stroke','black')
     .attr('stroke-width',0.7)
     .attr('x', d => xScale(xValue(d)))
     .attr('dx', '0.15em')
     .attr('y', d => yScale(yValue(d)))
     .attr('dy', yScale.bandwidth()*0.75)
     .attr('font-size', yScale.bandwidth()*0.8);

ylabEnter
  .merge(ylab)
     .text(d => d[0])
     .attr('fill',d =>
    (colorFont.hasOwnProperty(d[0])) 
    ? colorFont[d[0]] : colorFont["other"])
     .attr('stroke','black')
     .attr('stroke-width',0.2)
     .attr('x', 0)
     .attr('dx', '0.15em')
     .attr('y', d => yScale(yValue(d)))
     .attr('dy', yScale.bandwidth()*0.75)
     .attr('font-size', yScale.bandwidth()*0.4);


titleEnter
  .merge(title)
     .text(`Top rank of ${target}`)
     .attr('fill','white')
     .attr('x', 0)
     .attr('y', -5)
     .attr('stroke','red')
     .attr('stroke-width',0.8)
     .attr('font-size', 40);    
     
};