export const colorLegend = (selection, props) => {
  const {
     colorScale,
     circleRadius,
     spacing,
     textsize,
     textOffset,
     onClick_cl,
     clickObj_cl
   } = props;
  

   const back = selection.selectAll('rect').data([null])
   back.enter().append('rect')
     .attr('class','clback')
     .attr('width',140)
     .attr('height', spacing*colorScale.domain().length+2)
     .attr('x',-14)
     .attr('y',-14)
     .attr('rx',12)
   
   const groups = selection.selectAll('g')
     .data(colorScale.domain());
   const groupsEnter = groups.enter().append('g')
   groupsEnter
   .merge(groups)
     .attr('transform', (d, i) =>
         `translate(0, ${i * spacing})`)
     .attr('class','tick')
     .attr('opacity', d => (!clickObj_cl || d === clickObj_cl) ? 1 : 0.2)
     .on('click', d => onClick_cl( d === clickObj_cl ? null: d))
   
   groupsEnter.append('circle')
     .merge(groups.select('circle'))
       .attr('stroke','black')
       .attr('r', circleRadius)
       .attr('fill', colorScale)
  
   groupsEnter.append('text')
     .merge(groups.select('text'))
       .text(d => d)
       .attr('class','cltext')
       .attr('dy', '0.32em')
       .attr('x', textOffset)
       .attr('font-size', textsize);
   
 }