import {
  scaleLinear,  
  scaleBand,
  axisLeft,
  axisBottom,
  max
} from 'd3';

export const plot_stat = (selection,data) => {
                                    
  const colorScale = {
    "McDonald's":'#fffa05', 
    "Burger King":'#b21dc3', 
    "Taco Bell":'#2494fd',
    "Wendy's":'#fe2323', 
    "Arby's":'#fcc725',
    "KFC":'#fb7217',
    "Subway":'#7bfd24',
    "other": '#545454'
    }
  //console.log(colorScale["McDonald's"])
  
  
  
  const width = 300
  const height = 400
  const length =1
  
  const xValue = d => d[1]
  const yValue = d => d[0]
  
  const margin = { top: 130, right: 0, bottom: 50, left: 20 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  
  const xScale = scaleLinear()
    .domain([0, max(data, xValue)])
    .range([0, innerWidth]);
  
  const yScale = scaleBand()
    .domain(data.map(d => d[0]))
    .range([0, innerHeight])
    .padding(0.1);

//     const groups = selection.selectAll('g')
//     .data(colorScale.domain());
//   const groupsEnter = groups.enter().append('g')
  
  
  const groups = selection.selectAll('g').data(data);
  const groupsEnter = groups.enter().append('g')
  groupsEnter 
   .attr('transform', `translate(${margin.left},${margin.top})`);

//          var x = svg.selectAll(".x")
//            .data(["dummy"])
//         let newy = x.enter().append("g")

//        x.merge(newX).transition(t).call(xAxisCall)



 // groups
 //   .merge(groupsEnter).call(axisLeft(yScale))
  //  .exit(groupsEnter).remove()
  
  //groupsEnter.append('g')
  //  .merge(groups.select('g')).call(axisLeft(yScale));
  //  .attr('font-size', 40);
  //groupsEnter.append('g')
  //  .merge(groups.select('g')).call(axisBottom(xScale))
   // .attr('transform', `translate(0,${innerHeight})`);

  
  groupsEnter.append('rect')
  .merge(groups.select('rect'))
  .transition()
      .duration(750)
      .attr('rx',10) 
      .attr('y', d => yScale(yValue(d)))
      .attr('fill', d => 
    (+(colorScale.hasOwnProperty(d[0]))) ? colorScale[d[0]] : colorScale["other"])
      .attr('width', d => xScale(xValue(d)))
      .attr('height', yScale.bandwidth());
  

groupsEnter.append('text')
  .merge(groups.select('text'))
    .transition()
     .duration(250)
     .text(d => d[1])
     .attr('fill','white')
     .attr('x', d => xScale(xValue(d)))
     .attr('dx', '0.15em')
     .attr('y', d => yScale(yValue(d)))
     .attr('dy', yScale.bandwidth()*0.75)
     .attr('font-size', yScale.bandwidth()*0.8);
  

  
};